<?php
#################################################################################################
#
#  project           	 : phpBook
#  filename          	 : config.php
#  version           	 : 1.60
#  last modified by : Age Bosma
#  modify date        : 2005/06/13
#  e-mail            	 : age@hobba.nl
#  purpose           	 : Configuration File
#
#################################################################################################

// MySql Configuration
$cfg_server   = "localhost";  // Your MySQL Server, most cases "localhost"
$cfg_database = "phpBook";    // Your MySQL Database Name
$cfg_db_user  = "mysql_user"; // Your MySQL Username
$cfg_db_pass  = "mysql_pass"; // Your MySQL Password

// GB Parameters
$cfg_sitekey        = "dm56w69.3a2fDS+e9-SdFk*fa28367"; // Security Key for the image confirmation. DO CHANGE it to whatever you want, as long as you want. Just don't use quotes.
$cfg_adminpass      = "changeme";                       // Password for guestbook administration. CHANGE IT!!!
$cfg_gb_title       = "Guestbook";                      // Guestbook page title. Should be no-nonsense descriptive, using more than 60 characters is NOT recommended.
$cfg_gb_head        = "Guestbook";                      // Guestbook Header (Name).
$cfg_gb_desc        = "The best phpBook on the Net";    // Enter your description of the guestbook here.
$cfg_start_url      = "http://www.domain.com/book";     // Absolute guestbook location URL with NO trailing slashes
$cfg_notify_address = "webmaster@domain.com";           // Send entry notification to this address when a user adds a guestbook entry, leaving it empty will disable notify.
$cfg_gb_style       = "grayblue.css";                   // Specify the style sheet to use for the guestbook. Available files are: "grayblue.css" and "darkred.css".
$cfg_doctype        = "";                               // Set to "frames" if you plan to add the guestbook to a html frames based site (shame on you if you do ;) ).
$cfg_link_target    = "";                               // Enter e.g. "_blank" to open non-guetsbook related link URL's in a new browser window (NOT XHTML COMPLIANT!!!).

$cfg_censor         = true;  // Censor message based on the bad words list.
$cfg_ask_im_info    = true;  // Ask for Instant Messaging info (Jabber, ICQ, MSN, AIM and Yahoo) on post entry, set to false will also deactive IM icon display.
$cfg_visual_confirm = true;  // Ask for a visual confirmation when posting to reduce the amount of spam.
$cfg_location_text  = false; // If set to false you get a country location dropdown instead of a text input field (see $cfg_locations seeting).
$cfg_show_sysinfo   = false; // Show the system information on every bottom page, ask yourself the follwoing: do users realy need to know this kind of info?

$cfg_language  = "english.php";   // For e.g. German enter german.php (see languages sub-dir for supported file names)
$cfg_locations = "worldlong.inc"; // For e.g. Europe enter europe.inc (see locations sub-dir for supported file names)
$cfg_lang_dir  = "languages";			// Language Directory, no trailing slashes
$cfg_loc_dir   = "locations";     // Locations Directory, no trailing slashes
$cfg_image_dir = "images";        // Image Directory, no trailing slashes

$cfg_msg_limit    = array(5 ,1000); // Message Limits (min,max).
$cfg_time_limit   = "30";           // Submit timeout in minutes for flood protection, disabled if "".
$cfg_page_entries = "6";            // How much Entry's per page do you want to see?
$cfg_entry_pages  = "11";           // How much Page Break's per page, should be like 5,7,9,11,13
$cfg_table_width  = "600";          // Guestbook table width, enter value in pix (e.g. "600") or in % (e.g. "80%")
$cfg_table_align  = "center";       // To e.g. allign the guestbook table to the center of the page enter "center"
$cfg_date_format  = "eu";           // For european Date & Time Format enter "eu"
$cfg_supportpwd   = "2support";     // pwd for support-info, paranoid-setting is ""


#################################################################################################
#  End Configuration
#################################################################################################
#
#  !!! DO NOT EDIT ANYTHING BEHIND THIS LINE !!!
#
#################################################################################################

error_reporting(E_ALL & ~(E_WARNING | E_NOTICE));

if (extension_loaded("iconv")) {
	iconv_set_encoding("internal_encoding", "UTF-8");
	iconv_set_encoding("output_encoding", "UTF-8");
	iconv_set_encoding("input_encoding", "UTF-8");
}

require ("$cfg_lang_dir/english.php"); // Default language file is English in case the preferred language is missing a language string
require ("$cfg_lang_dir/$cfg_language");


#  Connect DB
#################################################################################################
mysql_connect($cfg_server, $cfg_db_user, $cfg_db_pass) or died("Database Connect Error");


#  Constants
#################################################################################################

  $cfg_gb_version = "1.60"; // DO NOT CHANGE THIS!!!

  if ($cfg_show_sysinfo) {
    list($usec, $sec) = explode(" ",$proctime_start);
    $proctime_start = $usec+$sec;

    list($usec, $sec) = explode(" ",microtime());
    $proctime_end = $usec+$sec;
    $proctime = $proctime_end-$proctime_start;

    $query = mysql_db_query($cfg_database, "SELECT id FROM guestbook");
    $countall=mysql_num_rows($query);

    $sysinfo = "<tr>\n<td colspan=\"2\" class=\"tablefooter\">\nProcessingtime: ".substr($proctime,0,7)." sec., Entries: $countall, PHP Ver. ".phpversion()."\n</td>\n</tr>\n";
  }
	else {
		$sysinfo = "";
	}

  #  PLEASE DO NOT REMOVE OR EDIT THIS COPYRIGHT-NOTICE !!! THANKS !!! ################################################
	if ($cfg_link_target != "") {
		$copyright = "<tr>\n<td colspan=\"2\" class=\"tablefooter\">\nphpBook Ver. $cfg_gb_version &copy; 2005 by <a href=\"http://age.hobba.nl\" target=\"$cfg_link_target\">Age Bosma</a>\n</td>\n</tr>\n";
	}
	else {
		$copyright = "<tr>\n<td colspan=\"2\" class=\"tablefooter\">\nphpBook Ver. $cfg_gb_version &copy; 2005 by <a href=\"http://age.hobba.nl\">Age Bosma</a>\n</td>\n</tr>\n";
	}
  #####################################################################################################################

#  Functions
#################################################################################################

	function str_repeats($input, $mult) {
		$ret = "";
		while ($mult > 0) {
			$ret .= $input;
			$mult --;
		}
		return $ret;
	}
	
	function died($message) {				//when we die, than with a nice screen ;-)
		global $cfg_gb_title, $cfg_gb_head, $cfg_languagemetatag, $cfg_table_width, $cfg_table_align, $cfg_gb_style;
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
		echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n";
		echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\">\n";
		echo "  <head>\n";
		echo "    <title>$cfg_gb_title</title>\n";
		echo "    <link rel=\"stylesheet\" type=\"text/css\" href=\"$cfg_gb_style\" />\n";
		echo "    $gb_languagemetatag\n";
		echo "  </head>\n";
		echo "  <body style=\"text-align: $cfg_table_align\">\n";
		echo "    <h1>$cfg_gb_head</h1>\n";
		echo "    <div class=\"error\" style=\"width: ".$cfg_table_width."px;\"><p>\n";
		echo $message;
		echo "    </p></div>\n";
		echo "  </body>\n";
		echo "</html>\n";
		exit;
	}
	
	function isbanned() {
		global $REMOTE_ADDR,$cfg_database;
		$ban_query = mysql_db_query($cfg_database, "SELECT * FROM banned_ips") or died("Database Query Error");
		while ($ip = mysql_fetch_row($ban_query)) {
			if ($ip["0"] == $REMOTE_ADDR) {
				return 1;
				exit;
			}
		}
		return 0;
	}
	
	function encode_msg ($msg) {
		global $cfg_image_dir,$cfg_database;
		if ($msg) {
			$msg = str_replace("\r", "", $msg);             // Replace carrige return
			$msg = str_replace("\n", "<br />", $msg); 	// Replace newline with <br />
			$result = mysql_db_query($cfg_database, "SELECT * FROM smilies") or died("Query Error");
			while ($db = mysql_fetch_array($result)) {
				$msg = str_replace($db[code], "<img src=''".$cfg_image_dir."/smilies/".$db[file]."'' alt=''".$db[name]." smiley'' />", $msg); // Smilie
			}
		}
		return $msg;
	}
	
	function urlcode_msg($msg) {
		global $cfg_link_target, $gb_user_image;
		if (get_magic_quotes_gpc()!=1) { $msg=addslashes($msg); }
		$msg = nl2br($msg);
		$msg = ereg_replace("javascript","",$msg);
		$msg = eregi_replace(quotemeta("[b]"),quotemeta("<b>"),$msg);
		$msg = eregi_replace(quotemeta("[/b]"),quotemeta("</b>"),$msg);
		$msg = eregi_replace(quotemeta("[i]"),quotemeta("<i>"),$msg);
		$msg = eregi_replace(quotemeta("[/i]"),quotemeta("</i>"),$msg);
		$msg = eregi_replace(quotemeta("[u]"),quotemeta("<u>"),$msg);
		$msg = eregi_replace(quotemeta("[/u]"),quotemeta("</u>"),$msg);
		if ($cfg_link_target != "") {
			$msg = eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" target=\"$cfg_link_target\" rel=\"nofollow\">\\1</a>",$msg);
			$msg = eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" target=\"$cfg_link_target\" rel=\"nofollow\">\\1</a>",$msg);
			$msg = eregi_replace("\\[url=([^\\[]*)\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" target=\"$cfg_link_target\" rel=\"nofollow\">\\2</a>",$msg);
		}
		else {
			$msg = eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]", "<a href=\"http://www.\\1\" rel=\"nofollow\">\\1</a>",$msg);
			$msg = eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" rel=\"nofollow\">\\1</a>",$msg);
			$msg = eregi_replace("\\[url=([^\\[]*)\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" rel=\"nofollow\">\\2</a>",$msg);
		}
		$msg = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\">\\1</a>",$msg);
		$msg = eregi_replace("\\[img\\]([^\\[]*)\\[/img\\]","<img src=\"\\1\" class=\"contentimage\" alt=\"$gb_user_image\" />",$msg);
	//	$msg = eregi_replace("\\[swf width=([^\\[]*) height=([^\\[]*)\\]([^\\[]*)\\[/swf\\]","<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=4\,0\,2\,0\" width=\"\\1\" height=\"\\2\"><param name=quality value=high><param name=\"SRC\" value=\"\\3\"><embed src=\"\\3\" quality=high pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"\\1\" height=\"\\2\"></embed></object>", $msg);
		return $msg;
	}
	
	function wordwrap_msg($msg, $maxwordlen=50) {
		$eachword = explode(" ", str_replace("<br />"," ",$msg));
		for ($i=0; $i<count($eachword); $i++) {
			if (strlen($eachword[$i])>$maxwordlen) {
				$msg = str_replace($eachword[$i], wordwrap($eachword[$i],$maxwordlen, " ", 1), $msg);
			}
		}
		return $msg;
	}
	
	function censor_msg($msg, $admin=0) {  // Badword-Replacement
		global $cfg_database, $cfg_censor;
		$msg = urlcode_msg($msg);
		$msg = wordwrap_msg($msg);
		$eachword = explode(" ", eregi_replace("<br />", " ", $msg));          // temp remove <br />
		if ($cfg_censor) {
			$result = mysql_db_query($cfg_database, "SELECT * FROM badwords") or died("Query Error");
			while ($db = mysql_fetch_array($result)) {
				for ($i=0; $i<count($eachword); $i++) {
					if (is_int(strpos(strtolower($eachword[$i]),$db[badword]))) {
						if($admin) {
							$msg = eregi_replace($eachword[$i], "<span class=\"censored\">".$eachword[$i]."</span>", stripslashes($msg)); // Badword
						} else {
							$msg = eregi_replace($eachword[$i], str_repeats("*", strlen($eachword[$i])), stripslashes($msg)); // Badword
						}
					}
				}
			}
		}
		$msg = str_replace("\'","'",$msg);

		if (!utf8_encode(utf8_decode($msg)) == $msg) { // Check if the string is already in UTF-8
			$msg = utf8_encode($msg); // If not, make it so
		}
		
		return $msg;
	}
	
	function decode_msg ($msg) {
		global $cfg_image_dir, $cfg_database;
		if ($msg) {
			$msg = str_replace("<br />", "\n", $msg); // Replace newline with <br>
			$result = mysql_db_query($cfg_database, "SELECT * FROM smilies") or died("Query Error");
			while ($db = mysql_fetch_array($result)) {
				$msg = str_replace("<img src='".$cfg_image_dir."/smilies/".$db[file]."' alt='".$db[name]." smiley' />",$db[code],$msg); // Smilie
			}
		}
		return $msg;
	}
	
	function strip_array ($in) {  //foreach()-Replacement !!!
		reset($in);
		while ($array=each($in)) {
			$ckey = $array['key'];
			$cvalue = $array['value'];
			$cvalue = str_replace("'", "''", $cvalue);
			$cvalue = stripslashes($cvalue);
			$cvalue = strip_tags($cvalue);
			$out[$ckey] = $cvalue;
		}
		return $out;
	}

#################################################################################################
#  EOF

?>